<?php
/*
 * Gpg Action Plugin.
 *
 * @license  Apache 2 (http://www.apache.org/licenses/LICENSE-2.0)
 * @author   Kazuyuki Matsuda <kazm@shorindo.com>
 */

class action_plugin_gpg extends DokuWiki_Action_Plugin {

	function getInfo() {
        return confToHash(dirname(__FILE__).'/plugin.info.txt');
	}

	function register(&$controller) {
        $controller->register_hook('AJAX_CALL_UNKNOWN',
                                   'BEFORE', $this, 'ajax');
        $controller->register_hook('TOOLBAR_DEFINE',
                                   'AFTER', $this, 'toolbar');
	}

    function ajax(&$event) {
        if ($event->data != 'gpg') return;
        $event->preventDefault();
        $event->stopPropagation();
        header("Content-Type: text/html; charset=UTF-8");
        $helper = plugin_load('helper', 'gpg');
        if (!$helper) {
            print "no helper";
            return;
        }
        
        switch ($_POST['cmd']) {
        case 'encrypt':
            print $helper->encrypt($_POST['text'], $_POST['pass']);
            break;
        case 'decrypt':
            print $helper->decrypt($_POST['text'], $_POST['pass']);
            break;
        case 'decrypt_html':
            print $helper->decrypt_html($_POST['id'], $_POST['pass']);
            break;
        default:
            print "invalid cmd";
        }
    }

    function toolbar(&$event) {
        //dbglog("toolbar(".print_r($event,1).")");
        $event->data[] = array(
            'type' => 'gpg',
            'title' => 'encrypt/decrypt',
            'icon' => DOKU_BASE.'lib/plugins/gpg/images/lock.png',
            'name' => 'encrypt/decrypt'
            );
    }
}
