<?php
/*
 * Gpg Syntax Plugin.
 *
 * @license  Apache 2 (http://www.apache.org/licenses/LICENSE-2.0)
 * @author   Kazuyuki Matsuda <kazm@shorindo.com>
 */

if (!defined('DOKU_INC')) die();
if (!defined('DOKU_LF')) define('DOKU_LF', "\n");
if (!defined('DOKU_TAB')) define('DOKU_TAB', "\t");
if (!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'syntax.php');

class syntax_plugin_gpg extends DokuWiki_Syntax_Plugin {
	function getInfo() {
        return confToHash(dirname(__FILE__).'/plugin.info.txt');
	}

	function getType() { return 'container'; }

	function getSort() { return 200; }

	function getPType() { return 'block';}

	function connectTo($mode) {
		$this->Lexer->addSpecialPattern('<gpg>[\s\S]*?</gpg>', $mode, 'plugin_gpg');
	}

	function handle($match, $state, $pos, &$handler) {
		return array($state, array());
    }

	function render($mode, &$renderer, $data) {
		if($mode == 'xhtml'){
            $renderer->doc .=
                '<div id="gpg__body">'.
                $this->getLang('caution').
                '<form action="javascript:void(0);">'.
                '<input type="password" class="edit" name="pass"/>&nbsp;'.
                '<input type="button" class="edit" value="'.
                $this->getLang('decrypt_button').
                '" onclick="plugin_gpg.decrypt_html(this.form)"/>'.
                '</form>'.
                '<div id="gpg__message" style="color:red;"></div>'.
                '</div>';
        }
    }
}
